package org.beliaj.knots.painters.impl;

import java.awt.event.MouseEvent;

import javax.swing.event.ChangeEvent;

import org.beliaj.knots.diagram.ILine;
import org.beliaj.knots.diagram.IPoint;
import org.beliaj.knots.painters.IEnum;
import org.beliaj.knots.painters.Actor;

public class DeleteActor extends Actor {

	/**
	 * 
	 */
	private final PaintDiagramClient client;
	private IPoint myCurrentPoint;
	private ILine myCurrentLine;
	private int i = 0;

	/**
	 * @param client
	 */
	DeleteActor(PaintDiagramClient client) {
		this.client = client;
	}

	public void mouseMoved(MouseEvent e) {
		
		IPoint point = this.client.myDiagram.findPoint(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()),
				this.client.myPointDiam);
		
		this.myCurrentPoint = null;
		this.client.mySelectedPoints.clear();
		this.myCurrentLine = null;
		this.client.mySelectedLines.clear();
		
		if (point != null){
			this.client.mySelectedPoints.clear();
			this.client.mySelectedPoints.add(point);
			if (point.getLine() != null){
				for (ILine line: point.getLine()){
					this.client.mySelectedLines.add(line);
				}
			}
			this.myCurrentPoint = point;
		} else {
			
			ILine line = this.client.myDiagram.findLine(this.client.fromRealXToOur(e.getX()),
					this.client.fromRealYToOur(e.getY()),
					2*this.client.myPointDiam);
			
			if (line != null){
				i++;
				this.myCurrentLine = line;
				this.client.mySelectedLines.add(line);
			} 
		}
		e.getComponent().repaint();
	}
	
	public void mousePressed(MouseEvent e) {
		if (this.myCurrentPoint != null){
			IPoint point1 = null;
			IPoint point2 = null;
			
			if (!this.myCurrentPoint.canConnect()){
				if (this.myCurrentPoint.getLine().get(0).getFPoint().equals(this.myCurrentPoint)){
					point1 = this.myCurrentPoint.getLine().get(1).getFPoint();
					point2 = this.myCurrentPoint.getLine().get(0).getSPoint();
				} else {
					point1 = this.myCurrentPoint.getLine().get(1).getSPoint();
					point2 = this.myCurrentPoint.getLine().get(0).getFPoint();
				}
			}
			
			this.client.myDiagram.removePoint(this.myCurrentPoint);
			
			if ((point1 != point2)&&(point1 != null)){
				this.client.myDiagram.connectPoints(point1, point2);
			}
			
			this.myCurrentPoint = null;
			
			
			
		} else if (this.myCurrentLine != null){
			this.client.myDiagram.removeLine(this.myCurrentLine);
			this.myCurrentLine = null;
		}
		
	}

	@Override
	public boolean isActionPossible() {
		return (this.client.myDiagram.getPoints().size() > 0);
	}

	@Override
	public IEnum getActionCode() {
		return ActionEnum.DELETE;
	}
	
}
