package org.beliaj.knots.painters.impl;

import java.awt.event.MouseEvent;
import java.util.List;

import javax.swing.event.ChangeEvent;

import org.beliaj.knots.diagram.IIntersection;
import org.beliaj.knots.diagram.ILine;
import org.beliaj.knots.painters.IEnum;
import org.beliaj.knots.painters.Actor;

public class IntrsActor extends Actor {

	
	private final PaintDiagramClient client;
	private IIntersection myCurrentIntersection;
	
	/**
	 * @param client
	 */
	IntrsActor(PaintDiagramClient client) {
		this.client = client;
	}
	
	public void mouseMoved(MouseEvent e) {
		IIntersection intrs = client.myDiagram.findIntersection(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()),
				this.client.myPointDiam);
		
		this.myCurrentIntersection = intrs;
		
		e.getComponent().repaint();
	}
	
	public void mousePressed(MouseEvent e){
		if (this.myCurrentIntersection != null ){
			this.client.myDiagram.swapLines(this.myCurrentIntersection);
		}
		e.getComponent().repaint();
	}

	@Override
	public boolean isActionPossible() {
		List<ILine> list = this.client.myDiagram.getLines();
		for (ILine line: list){
			if (line.getIntersections().size() > 0){
				return true;
			}
		}
		return false;
	}

	@Override
	public IEnum getActionCode() {
		return ActionEnum.SWAP;
	}
	
}
